-- HandyHands. Factorio mod: Automatically start handcrafting 1 item that is filtered in your quickbar whenever your crafting queue is empty. Prioritises items in your hand. It's like logistics slots for early game!
-- Copyright (C) 2016  Qon

-- This program is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.

-- This program is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.

-- You should have received a copy of the GNU General Public License
-- along with this program.  If not, see <http://www.gnu.org/licenses/>

script.on_event(defines.events.on_tick, function(event)
    if game.tick%3 ~= 0 then
        return
    end
    for i=1, #game.players do
        local p = game.players[i]
        if p.connected then
            local qb = p.get_quickbar()
            if qb ~= nil and qb.has_filters ~= false and p.crafting_queue_size == 0 then
                local filter = nil
                local cs = p.cursor_stack
                for j=1, #qb do
                    local item = qb.get_filter(j)
                    if item ~= nil then
                        local prio_filter = 1
                        if filter ~= nil then
                            prio_filter = count_items(p, filter)/game.item_prototypes[filter].stack_size
                        end
                        local prio_current = count_items(p, item)/game.item_prototypes[item].stack_size
                        if prio_current < 1 and (prio_current < prio_filter or (cs.valid_for_read and cs.name == item)) and p.get_craftable_count(item) > 0 and p.force.recipes[item] ~= nil and p.force.recipes[item].enabled == true then
                            filter = item
                            if cs.valid_for_read and cs.name == item then
                                break
                            end
                        end
                    end
                end
                if filter ~= nil then
                    p.begin_crafting{count=1, recipe=filter, silent=true}
                end
            end
        end
    end
end)

function count_items(player, item_name)
    local count = 0
    if player.cursor_stack.valid_for_read and player.cursor_stack.name == item_name then
        count = count + player.cursor_stack.count
    end
    count = count + player.get_inventory(defines.inventory.player_main).get_item_count(item_name) + player.get_quickbar().get_item_count(item_name)
    return count
end